#!/bin/bash

ThirdPartyPath="/app/C_CXX_LIB"
ProjectPath="/app/BackstageService"

export LD_LIBRARY_PATH="$ProjectPath/lib:$ThirdPartyPath/runtime/lib:$ThirdPartyPath/unixODBC/lib:$ThirdPartyPath/mysql/lib:$ThirdPartyPath"
export ODBCSYSINI="$ThirdPartyPath/unixODBC/etc"
export MySQLClientFileRootDirectory="/app/Web/public/File"
export RemoteDatabaseFileRootDirectory="/app/Web/public/File"

. /app/DBus/function.sh
WaitDbusComplete

# 指定要檢查的路徑
DIRECTORY="/app/runtime/project/extern"
PIDFILE="/tmp/children_pids"

# 清空PID文件
> "$PIDFILE"

# 捕捉退出信號並終止子程式
trap 'cleanup' EXIT

cleanup() 
{
    echo "Cleaning up..."
    if [ -f "$PIDFILE" ]; then
        while IFS= read -r pid; do
            if kill -9 "$pid" 2>/dev/null; then
                kill "$pid" 2>/dev/null
                echo "Terminated process $pid"
            fi
        done < "$PIDFILE"
        rm -f "$PIDFILE"
    fi
}

# 查找並執行可執行檔案，如果目錄存在
if [ -d "$DIRECTORY" ]; then
    for FILE in "$DIRECTORY"/*; do
        if [ -f "$FILE" ] && [ -x "$FILE" ]; then  # 確保是普通文件且可執行
            echo "Executing $FILE"
            "$FILE" &
            echo $! >> "$PIDFILE"  # 記錄子進程的PID
        fi
    done
else
    echo "Directory $DIRECTORY does not exist, skipping execution of external files."
fi

# 最後執行 BackstageService，不在背景執行
cd "$ProjectPath/bin"
./BackstageService
