OpcUaLocalServer.prototype._GetServer_ = function(XmlObject)
{
	var Form = $("#Main_Center-Content").find(".Form");
	var ServerName = Form.eq(0).find(".Row").eq(0).find(".Text").val();
	var Port = Form.eq(0).find(".Row").eq(1).find(".Text").val();
	XmlObject["OpcServerConfig"]["UaServerConfig"]["ServerName"] = ServerName + "@[NodeName]";
	XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["Url"] = "opc.tcp://[NodeName]:" + Port;
};

OpcUaLocalServer.prototype._GetUserIdentityTokens_ = function(XmlObject)
{
	var Form = $("#Main_Center-Content").find(".Form");
	var EnableAnonymous = Form.eq(6).find(".Row").eq(0).find(":checkbox").prop("checked");
	var EnableUserPw = Form.eq(6).find(".Row").eq(1).find(":checkbox").prop("checked");
	var EnableCertificate = Form.eq(6).find(".Row").eq(4).find(":checkbox").prop("checked");

	XmlObject["OpcServerConfig"]["UaServerConfig"]["UserIdentityTokens"]["EnableAnonymous"] = EnableAnonymous;
	XmlObject["OpcServerConfig"]["UaServerConfig"]["UserIdentityTokens"]["EnableUserPw"] = EnableUserPw;
	XmlObject["OpcServerConfig"]["UaServerConfig"]["UserIdentityTokens"]["EnableCertificate"] = EnableCertificate;
};

OpcUaLocalServer.prototype._GetServerCertificate_ = function(XmlObject) {
    var Form = $("#Main_Center-Content").find(".Form");
    var Organization = Form.eq(2).find(".Row").eq(1).find(".Text").val();
    var Unit = Form.eq(2).find(".Row").eq(2).find(".Text").val();
    var LocationName = Form.eq(2).find(".Row").eq(3).find(".Text").val();
    var State = Form.eq(2).find(".Row").eq(4).find(".Text").val();
    var Country = Form.eq(2).find(".Row").eq(5).find(".Text").val();
    var YearsValid = Form.eq(2).find(".Row").eq(6).find(".Text").val();
    var KeyLength = Form.eq(2).find(".Row").eq(7).find(".Select").val();
    var CertificateType = Form.eq(2).find(".Row").eq(8).find(".Select").val(); 
    var IPAddress1 = Form.eq(2).find(".Row").eq(9).find(".Text").val(); 

    let CertificateSettings = XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["CertificateStore"]["CertificateSettings"];

    if (CertificateSettings.Organization != Organization)
        clearCertificate = true;

    if (CertificateSettings.OrganizationUnit != Unit)
        clearCertificate = true;

    if (CertificateSettings.Locality != LocationName)
        clearCertificate = true;

    if (CertificateSettings.State != State)
        clearCertificate = true;

    if (CertificateSettings.Country != Country)
        clearCertificate = true;

    if (CertificateSettings.YearsValidFor != YearsValid)
        clearCertificate = true;

    if (CertificateSettings.KeyLength != KeyLength)
        clearCertificate = true;

    // Add new conditions for Certificate Type and IP
    if (CertificateSettings.CertificateType != CertificateType)
        clearCertificate = true;

    if (CertificateSettings.IPAddress != IPAddress1)
        clearCertificate = true;

    CertificateSettings["CommonName"] = "[ServerName]";
    CertificateSettings["Organization"] = Organization;
    CertificateSettings["OrganizationUnit"] = Unit;
    CertificateSettings["Locality"] = LocationName;
    CertificateSettings["State"] = State;
    CertificateSettings["Country"] = Country;
    CertificateSettings["YearsValidFor"] = YearsValid;
    CertificateSettings["KeyLength"] = KeyLength;
    CertificateSettings["CertificateType"] = CertificateType;
	if (IPAddress1 === "") {
        delete CertificateSettings["IPAddress"]; 
    } else {
        CertificateSettings["IPAddress"] = IPAddress1; 
    } 
};

OpcUaLocalServer.prototype._GetSecuritySetting_ = function(XmlObject)
{
	var SecuritySettingArray = new Array();

	var Form = $("#Main_Center-Content").find(".Form");
	var None = Form.eq(4).find(".Flex").eq(0).find(":checkbox").prop("checked");
	var Basic128Rsa15 = Form.eq(4).find(".Flex").eq(1).find(":checkbox").prop("checked");
	var Policy_Basic128Rsa15 = Form.eq(4).find(".Flex").eq(1).find(".Select").val();
	var Basic256 = Form.eq(4).find(".Flex").eq(2).find(":checkbox").prop("checked");
	var Policy_Basic256 = Form.eq(4).find(".Flex").eq(2).find(".Select").val();
	var Basic256Sha256 = Form.eq(4).find(".Flex").eq(3).find(":checkbox").prop("checked");
	var Policy_Basic256Sha256 = Form.eq(4).find(".Flex").eq(3).find(".Select").val();
	var Aes128_Sha256_RsaOaep = Form.eq(4).find(".Flex").eq(4).find(":checkbox").prop("checked");
	var Policy_Aes128_Sha256_RsaOaep = Form.eq(4).find(".Flex").eq(4).find(".Select").val();
	var Aes256_Sha256_RsaPss = Form.eq(4).find(".Flex").eq(5).find(":checkbox").prop("checked");
	var Policy_Aes256_Sha256_RsaPss = Form.eq(4).find(".Flex").eq(5).find(".Select").val();


	XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["SecuritySetting"] = null; delete XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["SecuritySetting"];
	XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["SecuritySetting"] = new Array();
	if( None == true )
	{
		let PolicyObject = {
			"SecurityPolicy": "http://opcfoundation.org/UA/SecurityPolicy#None",
			"MessageSecurityMode": []
		};
		PolicyObject["MessageSecurityMode"] = "None";
		XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["SecuritySetting"].push(PolicyObject);
	}

	if( Basic128Rsa15 == true )
	{
		let PolicyObject = {
			"SecurityPolicy": "http://opcfoundation.org/UA/SecurityPolicy#Basic128Rsa15",
			"MessageSecurityMode": []
		};

		if(Policy_Basic128Rsa15 == "Sign") PolicyObject["MessageSecurityMode"].push("Sign");
		else if(Policy_Basic128Rsa15 == "Sign&Encrypt") PolicyObject["MessageSecurityMode"].push("SignAndEncrypt");
		else if(Policy_Basic128Rsa15 == "Sign/Sign&Encrypt")
		{
			PolicyObject["MessageSecurityMode"].push("Sign");
			PolicyObject["MessageSecurityMode"].push("SignAndEncrypt");
		}

		XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["SecuritySetting"].push(PolicyObject);
	}

	if( Basic256 == true )
	{
		
		let PolicyObject = {
			"SecurityPolicy": "http://opcfoundation.org/UA/SecurityPolicy#Basic256",
			"MessageSecurityMode": []
		};

		if(Policy_Basic256 == "Sign") PolicyObject["MessageSecurityMode"].push("Sign");
		else if(Policy_Basic256 == "Sign&Encrypt") PolicyObject["MessageSecurityMode"].push("SignAndEncrypt");
		else if(Policy_Basic256 == "Sign/Sign&Encrypt")
		{
			PolicyObject["MessageSecurityMode"].push("Sign");
			PolicyObject["MessageSecurityMode"].push("SignAndEncrypt");
		}

		XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["SecuritySetting"].push(PolicyObject);
	}
	
	if(Basic256Sha256 == true)
	{
		let PolicyObject = {
			"SecurityPolicy": "http://opcfoundation.org/UA/SecurityPolicy#Basic256Sha256",
			"MessageSecurityMode": []
		};

		if(Policy_Basic256Sha256 == "Sign") PolicyObject["MessageSecurityMode"].push("Sign");
		else if(Policy_Basic256Sha256 == "Sign&Encrypt") PolicyObject["MessageSecurityMode"].push("SignAndEncrypt");
		else if(Policy_Basic256Sha256 == "Sign/Sign&Encrypt")
		{
			PolicyObject["MessageSecurityMode"].push("Sign");
			PolicyObject["MessageSecurityMode"].push("SignAndEncrypt");
		}

		XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["SecuritySetting"].push(PolicyObject);
	}

	if(Aes128_Sha256_RsaOaep == true)
	{
		let PolicyObject = {
			"SecurityPolicy": "http://opcfoundation.org/UA/SecurityPolicy#Aes128_Sha256_RsaOaep",
			"MessageSecurityMode": []
		};

		if(Policy_Aes128_Sha256_RsaOaep == "Sign") PolicyObject["MessageSecurityMode"].push("Sign");
		else if(Policy_Aes128_Sha256_RsaOaep == "Sign&Encrypt") PolicyObject["MessageSecurityMode"].push("SignAndEncrypt");
		else if(Policy_Aes128_Sha256_RsaOaep == "Sign/Sign&Encrypt")
		{
			PolicyObject["MessageSecurityMode"].push("Sign");
			PolicyObject["MessageSecurityMode"].push("SignAndEncrypt");
		}

		XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["SecuritySetting"].push(PolicyObject);
	}

	if(Aes256_Sha256_RsaPss == true)
	{
		let PolicyObject = {
			"SecurityPolicy": "http://opcfoundation.org/UA/SecurityPolicy#Aes256_Sha256_RsaPss",
			"MessageSecurityMode": []
		};

		if(Policy_Aes256_Sha256_RsaPss == "Sign") PolicyObject["MessageSecurityMode"].push("Sign");
		else if(Policy_Aes256_Sha256_RsaPss == "Sign&Encrypt") PolicyObject["MessageSecurityMode"].push("SignAndEncrypt");
		else if(Policy_Aes256_Sha256_RsaPss == "Sign/Sign&Encrypt")
		{
			PolicyObject["MessageSecurityMode"].push("Sign");
			PolicyObject["MessageSecurityMode"].push("SignAndEncrypt");
		}

		XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["SecuritySetting"].push(PolicyObject);
	}
};


OpcUaLocalServer.prototype._SetServerUi_ = function(XmlObject)
{
	var ServerName = XmlObject["OpcServerConfig"]["UaServerConfig"]["ServerName"].split("@")[0];
	var Port =  XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["Url"].split(":")[2];
	var Form = $("#Main_Center-Content").find(".Form");
	Form.eq(0).find(".Row").eq(0).find(".Text").val(ServerName);
	Form.eq(0).find(".Row").eq(1).find(".Text").val(Port);
};

OpcUaLocalServer.prototype._SetUserIdentityTokensUi_ = function(XmlObject)
{
	var EnableAnonymous = JSON.parse(XmlObject["OpcServerConfig"]["UaServerConfig"]["UserIdentityTokens"]["EnableAnonymous"]);
	var EnableUserPw = JSON.parse(XmlObject["OpcServerConfig"]["UaServerConfig"]["UserIdentityTokens"]["EnableUserPw"]);
	var EnableCertificate =  JSON.parse(XmlObject["OpcServerConfig"]["UaServerConfig"]["UserIdentityTokens"]["EnableCertificate"]);

	var Form = $("#Main_Center-Content").find(".Form");
	Form.eq(6).find(".Row").eq(0).find(":checkbox").prop("checked",EnableAnonymous);
	Form.eq(6).find(".Row").eq(1).find(":checkbox").prop("checked",EnableUserPw);
	toggleAccountPasswordFields(EnableUserPw);
	Form.eq(6).find(".Row").eq(4).find(":checkbox").prop("checked",EnableCertificate);
};

OpcUaLocalServer.prototype._SetServerCertificate_ = function(XmlObject)
 {
    var Organization = XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["CertificateStore"]["CertificateSettings"]["Organization"];
    var OrganizationUnit = XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["CertificateStore"]["CertificateSettings"]["OrganizationUnit"];
    var Locality = XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["CertificateStore"]["CertificateSettings"]["Locality"];
    var State = XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["CertificateStore"]["CertificateSettings"]["State"];
    var Country = XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["CertificateStore"]["CertificateSettings"]["Country"];
    var YearsValidFor = XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["CertificateStore"]["CertificateSettings"]["YearsValidFor"];
    var KeyLength = XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["CertificateStore"]["CertificateSettings"]["KeyLength"];
    
	var CertificateType = XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["CertificateStore"]["CertificateSettings"]["CertificateType"] || "RsaSha256"; // New variable for Certificate Type
	var IPAddressList = XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["CertificateStore"]["CertificateSettings"]["IPAddress"] || []; // New variable for IP list
    if (typeof IPAddressList === 'string') {
		IPAddressList = [IPAddressList];
	}
	var IPAddress1 = IPAddressList[0] || "";
	
    var Form = $("#Main_Center-Content").find(".Form");
    Form.eq(2).find(".Row").eq(0).find(".Text").val("Server Name");
    Form.eq(2).find(".Row").eq(1).find(".Text").val(Organization);
    Form.eq(2).find(".Row").eq(2).find(".Text").val(OrganizationUnit);
    Form.eq(2).find(".Row").eq(3).find(".Text").val(Locality);
    Form.eq(2).find(".Row").eq(4).find(".Text").val(State);
    Form.eq(2).find(".Row").eq(5).find(".Text").val(Country);
    Form.eq(2).find(".Row").eq(6).find(".Text").val(YearsValidFor);
	var KeyLengthOptionExists = Form.eq(2).find(".Row").eq(7).find(".Select option[value='" + KeyLength + "']").length > 0;
	if (!KeyLengthOptionExists) {
		Form.eq(2).find(".Row").eq(7).find(".Select").append(new Option(KeyLength, KeyLength));
	}
	Form.eq(2).find(".Row").eq(7).find(".Select").val(KeyLength);
    Form.eq(2).find(".Row").eq(8).find(".Select").val(CertificateType); 
    Form.eq(2).find(".Row").eq(9).find(".Text").val(IPAddress1); 
};


OpcUaLocalServer.prototype._SetSecurityPolicyNone_ = function(MessageSecurityModeArray)
{
	var Form = $("#Main_Center-Content").find(".Form");
	Form.eq(4).find(".Row").find(".Flex").eq(0).find(":checkbox").prop("checked", true);
};

OpcUaLocalServer.prototype._SetSecurityPolicyBasic128Rsa15_ = function(MessageSecurityModeArray)
{
	var Form = $("#Main_Center-Content").find(".Form");
	Form.eq(4).find(".Row").find(".Flex").eq(1).find(":checkbox").prop("checked", true);

	if( Array.isArray( MessageSecurityModeArray ) != true )
	{
		if( MessageSecurityModeArray == "Sign" )
		{
			Form.eq(4).find(".Row").find(".Flex").eq(1).find(".Select").val("Sign");
		}
		else if( MessageSecurityModeArray == "SignAndEncrypt" )
		{
			Form.eq(4).find(".Row").find(".Flex").eq(1).find(".Select").val("Sign&Encrypt");
		}
	}
	else
	{
		Form.eq(4).find(".Row").find(".Flex").eq(1).find(".Select").val("Sign/Sign&Encrypt");
	}
};

OpcUaLocalServer.prototype._SetSecurityPolicyBasic256_ = function(MessageSecurityModeArray)
{
	var Form = $("#Main_Center-Content").find(".Form");
	Form.eq(4).find(".Row").find(".Flex").eq(2).find(":checkbox").prop("checked", true);

	if( Array.isArray( MessageSecurityModeArray ) != true )
	{
		if( MessageSecurityModeArray == "Sign" )
		{
			Form.eq(4).find(".Row").find(".Flex").eq(2).find(".Select").val("Sign");
		}
		else if( MessageSecurityModeArray == "SignAndEncrypt" )
		{
			Form.eq(4).find(".Row").find(".Flex").eq(2).find(".Select").val("Sign&Encrypt");
		}
	}
	else
	{
		Form.eq(4).find(".Row").find(".Flex").eq(2).find(".Select").val("Sign/Sign&Encrypt");
	}
};

OpcUaLocalServer.prototype._SetSecurityPolicyBasic256Sha256_ = function(MessageSecurityModeArray)
{
	var Form = $("#Main_Center-Content").find(".Form");
	Form.eq(4).find(".Row").find(".Flex").eq(3).find(":checkbox").prop("checked", true);

	if( Array.isArray( MessageSecurityModeArray ) != true )
	{
		if( MessageSecurityModeArray == "Sign" )
		{
			Form.eq(4).find(".Row").find(".Flex").eq(3).find(".Select").val("Sign");
		}
		else if( MessageSecurityModeArray == "SignAndEncrypt" )
		{
			Form.eq(4).find(".Row").find(".Flex").eq(3).find(".Select").val("Sign&Encrypt");
		}
	}
	else
	{
		Form.eq(4).find(".Row").find(".Flex").eq(3).find(".Select").val("Sign/Sign&Encrypt");
	}
};

OpcUaLocalServer.prototype._SetSecurityPolicyAes128_Sha256_RsaOaep_ = function(MessageSecurityModeArray)
{
	var Form = $("#Main_Center-Content").find(".Form");
	Form.eq(4).find(".Row").find(".Flex").eq(4).find(":checkbox").prop("checked", true);

	if( Array.isArray( MessageSecurityModeArray ) != true )
	{
		if( MessageSecurityModeArray == "Sign" )
		{
			Form.eq(4).find(".Row").find(".Flex").eq(4).find(".Select").val("Sign");
		}
		else if( MessageSecurityModeArray == "SignAndEncrypt" )
		{
			Form.eq(4).find(".Row").find(".Flex").eq(4).find(".Select").val("Sign&Encrypt");
		}
	}
	else
	{
		Form.eq(4).find(".Row").find(".Flex").eq(4).find(".Select").val("Sign/Sign&Encrypt");
	}
};

OpcUaLocalServer.prototype._SetSecurityPolicyAes256_Sha256_RsaPss_ = function(MessageSecurityModeArray)
{
	var Form = $("#Main_Center-Content").find(".Form");
	Form.eq(4).find(".Row").find(".Flex").eq(5).find(":checkbox").prop("checked", true);

	if( Array.isArray( MessageSecurityModeArray ) != true )
	{
		if( MessageSecurityModeArray == "Sign" )
		{
			Form.eq(4).find(".Row").find(".Flex").eq(5).find(".Select").val("Sign");
		}
		else if( MessageSecurityModeArray == "SignAndEncrypt" )
		{
			Form.eq(4).find(".Row").find(".Flex").eq(5).find(".Select").val("Sign&Encrypt");
		}
	}
	else
	{
        Form.eq(4).find(".Row").find(".Flex").eq(5).find(".Select").val("Sign/Sign&Encrypt");
    }
};

OpcUaLocalServer.prototype._SetSecuritySetting_ = function(XmlObject)
{
	var array = XmlObject["OpcServerConfig"]["UaServerConfig"]["UaEndpoint"]["SecuritySetting"];
	for(var i=0; i<array.length; i++)
	{
		var SecurityPolicy = array[i]["SecurityPolicy"];
		var MessageSecurityModeArray = array[i]["MessageSecurityMode"];

		if( SecurityPolicy == "http://opcfoundation.org/UA/SecurityPolicy#None" )
		{
			OpcUaLocalServer.prototype._SetSecurityPolicyNone_(MessageSecurityModeArray);
		}
		else if( SecurityPolicy == "http://opcfoundation.org/UA/SecurityPolicy#Basic128Rsa15" )
		{
			OpcUaLocalServer.prototype._SetSecurityPolicyBasic128Rsa15_(MessageSecurityModeArray);
		}
		else if( SecurityPolicy == "http://opcfoundation.org/UA/SecurityPolicy#Basic256" )
		{
			OpcUaLocalServer.prototype._SetSecurityPolicyBasic256_(MessageSecurityModeArray);
		}else if (SecurityPolicy == "http://opcfoundation.org/UA/SecurityPolicy#Basic256Sha256") {
			OpcUaLocalServer.prototype._SetSecurityPolicyBasic256Sha256_(MessageSecurityModeArray);
		}else if (SecurityPolicy == "http://opcfoundation.org/UA/SecurityPolicy#Aes128_Sha256_RsaOaep")
		 {
			OpcUaLocalServer.prototype._SetSecurityPolicyAes128_Sha256_RsaOaep_(MessageSecurityModeArray);
		}else if (SecurityPolicy == "http://opcfoundation.org/UA/SecurityPolicy#Aes256_Sha256_RsaPss") 
		{
			OpcUaLocalServer.prototype._SetSecurityPolicyAes256_Sha256_RsaPss_(MessageSecurityModeArray);
		}
	}
};


OpcUaLocalServer.prototype._ShowUi_ = async function() 
{
	var XmlObject = Global_OpcUaLocalServer;
    await OpcUaLocalServer.prototype._GetServerCredentials_()
    .catch((error) => {
            });
    OpcUaLocalServer.prototype._SetServerUi_(XmlObject);
    OpcUaLocalServer.prototype._SetUserIdentityTokensUi_(XmlObject);
    OpcUaLocalServer.prototype._SetServerCertificate_(XmlObject);
    OpcUaLocalServer.prototype._SetSecuritySetting_(XmlObject);

};

OpcUaLocalServer.prototype._GetServerCredentials_ = function() {
    return new Promise((resolve, reject) => {
        var ssocket = io.connect();
        ssocket.emit('GetOPCUA_Credentials');
        ssocket.on("GetOPCUA_Credentials", function (Return) {
			if(Return.Return==true)
			{
			let  username = Return.Obj.username;
			let  password = Return.Obj.password;
			$('#ServerUesrName').val(username);
			if(password==="")
			{
				$('#ServerPassword').val("");

			}
            resolve();
			}
            else
			{
             $('#ServerUesrName').val("");
			 $('#ServerPassword').val("");
             reject();
			}
        });
    });
};

OpcUaLocalServer.prototype._SetServerCredentials_ = function (that) {

	if(opcua_usernameInput==true)
	 that.username= $("#ServerUesrName").val();
    
	if(opcua_passwordInput==true)
      that.password = $("#ServerPassword").val();
};

OpcUaLocalServer.prototype._checkInput_ = function() {
    var account = $('#ServerUesrName').val();
    var password = $('#ServerPassword').val();
    var accountRegex = /^[a-zA-Z0-9]+$/;
    var result = true;
	
    if(password==="")
	{
		result = false;
	}
    if (opcua_usernameInput == true) {
        if (!accountRegex.test(account)) {
			let text=Global_TranslateJson["/html/Center/LocalServer.html___UserName Characters Error"];
            alert(text);
            result = false;
        } else if (account.trim() === '') {
			let text=Global_TranslateJson["/html/Center/LocalServer.html___UserName Empty Error"];
            alert(text );
            result = false;
        }
    }
	else if(account.trim() === '')
	{
		let text=Global_TranslateJson["/html/Center/LocalServer.html___UserName Empty Error"];
		alert(text);
		result = false;
	}

    if (opcua_passwordInput == true) {
        if (password.length < 6) {
			let text=Global_TranslateJson["/html/Center/LocalServer.html___Password Error"];
			alert(text);
            result = false;
        }
    }else if( password==="")
	{
		let text=Global_TranslateJson["/html/Center/LocalServer.html___Password Error"];
			alert(text); 
		result = false;
	}

    return result;
}

OpcUaLocalServer.prototype._IsSaveCredentials_= function()
{	
    if(OpcUaLocalServer.prototype._checkInput_()==false)
	  	return false;
	return true;
}

OpcUaLocalServer.prototype._SaveServer_ = function(that)
{
	var XmlObject = Global_OpcUaLocalServer;
	if(that.id=="OpcUa_SaveServer")
	{
		OpcUaLocalServer.prototype._GetServerCertificate_(XmlObject);
		OpcUaLocalServer.prototype._GetSecuritySetting_(XmlObject);
		OpcUaLocalServer.prototype._GetUserIdentityTokens_(XmlObject);
	}
	
	var xotree = new XML.ObjTree();
	var xml = xotree.writeXML(XmlObject);
	var ssocket = io.connect();
	var array = new Array(xml);
	OpcUaLocalServer.prototype._TransmissionData_(that, array, ssocket);
};

OpcUaLocalServer.prototype._SaveUserIdentityTokens_ = function(that)
{
	var Class = new LoadFile();
	var XmlObject = Global_OpcUaLocalServer;
	OpcUaLocalServer.prototype._GetUserIdentityTokens_(XmlObject);

	var xotree = new XML.ObjTree();
	var xml = xotree.writeXML(XmlObject);

	var ssocket = io.connect();
	var array = new Array(xml);
	OpcUaLocalServer.prototype._TransmissionData_(that, array, ssocket);
};

OpcUaLocalServer.prototype._SaveServerCertificate_ = function(that)
{
	var XmlObject = Global_OpcUaLocalServer;

	OpcUaLocalServer.prototype._GetServerCertificate_(XmlObject);

	var xotree = new XML.ObjTree();
	var xml = xotree.writeXML(XmlObject);

	var ssocket = io.connect();
	var array = new Array(xml);
	OpcUaLocalServer.prototype._TransmissionData_(that, array, ssocket);
};

OpcUaLocalServer.prototype._SaveSecuritySetting_ = function(that)
{
	var XmlObject = Global_OpcUaLocalServer;

	OpcUaLocalServer.prototype._GetSecuritySetting_(XmlObject);

	var xotree = new XML.ObjTree();
	var xml = xotree.writeXML(XmlObject);

	var ssocket = io.connect();
	var array = new Array(xml);
	OpcUaLocalServer.prototype._TransmissionData_(that, array, ssocket);
};
  
	


OpcUaLocalServer.prototype._TransmissionData_ = function(that, array, ssocket)
{
	that.disabled = true;
	$(that).closest('.Row').find(".Message").hide();
	$(that).closest('.Row').find(".Loading").show();
	$('#Check_ServerUesrName').hide();
	$('#Check_ServerPassword').hide();
	var credentials = {username: "", password: ""};
	
	if(that.id=="OpcUa_SaveServer")
	{
		let isChecked = $('#UserPasswordLogin').is(':checked');
        if(isChecked==true)
	    { 
		 if(OpcUaLocalServer.prototype._IsSaveCredentials_()==false)
		 {
            $(that).closest('.Row').find(".Loading").hide();
			that.disabled = false;
			return ;
		 }	
		  OpcUaLocalServer.prototype._SetServerCredentials_(credentials);
		}
	}
	var data = {array: array,isClearCertificate: clearCertificate ,credentials: credentials};
	
	ssocket.emit('SaveOpcUaLocalServer', data);
	ssocket.on('SaveOpcUaLocalServer', function (Return) {
		if(Return == true )
		{
			$(that).closest('.Row').find(".Loading").hide();
			$(that).closest('.Row').find(".Message").eq(0).show();
			that.disabled = false;
		}	
		else
		{
			$(that).closest('.Row').find(".Loading").hide();
			$(that).closest('.Row').find(".Message").eq(1).show();
			that.disabled = false;
		}
		ssocket.emit("SocketClose");
	});
};

OpcUaLocalServer.prototype._CheckPort_ = function(that)
{
	var Port = $(that).closest('.Row').find(".Text").val();
	var Class = new Type();
	if(Class.CheckPositiveIntegers(Port) == false)
	{
		$(that).closest('.Row').find(".Text").val(48010);
	}
	OpcUaLocalServer.prototype._SynchronizeModifyGlobalVariable_("Server");
};

OpcUaLocalServer.prototype._SynchronizeModifyGlobalVariable_ = function(Mode)
{
	var XmlObject = Global_OpcUaLocalServer;
	if(Mode == "Server")
	{
		OpcUaLocalServer.prototype._GetServer_(XmlObject);
	}
	else if("UserIdentityTokens")
	{
		OpcUaLocalServer.prototype._GetUserIdentityTokens_(XmlObject);
	}
};